Package org.codehaus.groovy.transform

## Class CategoryASTTransformation

- java.lang.Object
- - org.codehaus.groovy.transform.CategoryASTTransformation

- All Implemented Interfaces:
    `ASTTransformation`

      public class CategoryASTTransformation
      extends Object
      implements ASTTransformation

  Handles generation of code for the @Category annotation.

  Transformation logic is as follows:

  - all non-static methods converted to static ones with an additional 'self' parameter
  - references to 'this' changed to the additional 'self' parameter

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CategoryASTTransformation()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `visit​(ASTNode[] nodes, SourceUnit sourceUnit)` | The method is invoked when an AST Transformation is active.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CategoryASTTransformation

          public CategoryASTTransformation()

  - ### Method Detail

    - #### visit

          public void visit​(ASTNode[] nodes,
                            SourceUnit sourceUnit)

      Description copied from interface: `ASTTransformation`
      The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
      Specified by:
        `visit` in interface `ASTTransformation`
      Parameters:
        `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
        `sourceUnit` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.